# DebugAppearance

#### new Cesium.DebugAppearance(options)
Scene/DebugAppearance.js 35

Visualizes a vertex attribute by displaying it as a color for debugging.

Components for well-known unit-length vectors, i.e., `normal`, `tangent`, and `bitangent`, are scaled and biased from [-1.0, 1.0] to (-1.0, 1.0).

Name | Type | Description
--- | --- | ---
`options` | Object | Object with the following properties:
Name | Type | Default | Description
--- | --- | --- | ---
`attributeName` | String |  | The name of the attribute to visualize.
`perInstanceAttribute` | Boolean | `false` | optional Boolean that determines whether this attribute is a per-instance geometry attribute.
`glslDatatype` | String | `'vec3'` | optional The GLSL datatype of the attribute. Supported datatypes are `float`, `vec2`, `vec3`, and `vec4`.
`vertexShaderSource` | String |  | optional Optional GLSL vertex shader source to override the default vertex shader.
`fragmentShaderSource` | String |  | optional Optional GLSL fragment shader source to override the default fragment shader.
`renderState` | Object |  | optional Optional render state to override the default render state.

##### Throws:

- DeveloperError : options.glslDatatype must be float, vec2, vec3, or vec4.

##### Example:

    var primitive = new Cesium.Primitive({
      geometryInstances : // ...
      appearance : new Cesium.DebugAppearance({
        attributeName : 'normal'
      })
    });

### Members

#### readonly attributeName : String
Scene/DebugAppearance.js 231

The name of the attribute being visualized.

#### readonly closed : Boolean
Scene/DebugAppearance.js 217

When `true`, the geometry is expected to be closed.

Default Value: `false`

#### readonly fragmentShaderSource : String
Scene/DebugAppearance.js 187

The GLSL source code for the fragment shader. The full fragment shader source is built procedurally taking into account the `DebugAppearance#material`. Use `DebugAppearance#getFragmentShaderSource` to get the full source.

#### readonly glslDatatype : String
Scene/DebugAppearance.js 245

The GLSL datatype of the attribute being visualized.

#### material : Material
Scene/DebugAppearance.js 136

This property is part of the `Appearance` interface, but is not used by `DebugAppearance` since a fully custom fragment shader is used.

Default Value: `undefined`

#### readonly renderState : Object
Scene/DebugAppearance.js 201

The WebGL fixed-function state to use when rendering the geometry.

#### translucent : Boolean
Scene/DebugAppearance.js 145

When `true`, the geometry is expected to appear translucent.

Default Value: `false`

#### readonly vertexShaderSource : String
Scene/DebugAppearance.js 171

The GLSL source code for the vertex shader.

### Methods

#### getFragmentShaderSource() → String
Scene/DebugAppearance.js 260

Returns the full GLSL fragment shader source, which for `DebugAppearance` is just `DebugAppearance#fragmentShaderSource`.

##### Returns:

The full GLSL fragment shader source.

#### getRenderState() → Object
Scene/DebugAppearance.js 281

Creates a render state. This is not the final render state instance; instead, it can contain a subset of render state properties identical to the render state created in the context.

##### Returns:

The render state.

#### isTranslucent() → Boolean
Scene/DebugAppearance.js 270

Determines if the geometry is translucent based on `DebugAppearance#translucent`.

##### Returns:

`true` if the appearance is translucent.